
Ext.namespace('DSS.types');Ext.define('DSS.Scenes',{statics:{OFF:0,USER1:5,USER2:17,USER3:18,USER4:19,DEC:11,INC:12,MIN:13,MAX:14,STOP:15,LOCAL_OFF:50,LOCAL_ON:51,AUTO_STANDBY:64,PANIC:65,ENERGY_OVERLOAD:66,STANDBY:67,DEEP_OFF:68,SLEEPING:69,WAKE_UP:70,PRESENT:71,ABSENT:72,BELL:73,ALARM:74,toModel:function(scn){return Ext.create('DSS.apartment.SceneModel',{id:scn,text:DSS.Scenes.toString(scn)});},toString:function(scn,grp){switch(scn){case DSS.Scenes.OFF:switch(grp){case DSS.Groups.LIGHT:case DSS.Groups.VIDEO:return _("Off");case DSS.Groups.CLIMATE:return _("Close");default:return _("Scene 0");}
case DSS.Scenes.USER1:switch(grp){case DSS.Groups.CLIMATE:return _("Close");default:return _("Scene 1");}
case DSS.Scenes.USER2:return _("Scene 2");case DSS.Scenes.USER3:return _("Scene 3");case DSS.Scenes.USER4:return _("Scene 4");case DSS.Scenes.DEC:return _("Dim down");case DSS.Scenes.INC:return _("Dim up");case DSS.Scenes.MIN:return _("Off");case DSS.Scenes.MAX:return _("On");case DSS.Scenes.STOP:return _("Stop");case DSS.Scenes.LOCAL_ON:return _("On with local priority");case DSS.Scenes.LOCAL_OFF:return _("Off with local priority");case DSS.Scenes.AUTO_STANDBY:return _("Auto standby");case DSS.Scenes.PANIC:return _("Panic");case DSS.Scenes.ENERGY_OVERLOAD:return _("Energy overload");case DSS.Scenes.STANDBY:return _("Standby");case DSS.Scenes.DEEP_OFF:return _("Deep off");case DSS.Scenes.SLEEPING:return _("Sleeping");case DSS.Scenes.WAKE_UP:return _("Wake up");case DSS.Scenes.PRESENT:return _("Present");case DSS.Scenes.ABSENT:return _("Absent");case DSS.Scenes.BELL:return _("Bell");case DSS.Scenes.ALARM:return _("Alarm");default:return _("error");}}}});Ext.define('DSS.Groups',{statics:{ALL:0,ANY:0,LIGHT:1,SHADOW:2,CLIMATE:3,AUDIO:4,VIDEO:5,SECURITY:6,ACCESS:7,JOKER:8,WHITE:9,DISPLAYS:10,toString:function(grp){switch(grp){case DSS.Groups.ALL:return _("All groups");case DSS.Groups.ANY:return _("Any group");case DSS.Groups.LIGHT:return _("Light");case DSS.Groups.SHADOW:return _("Shadow");case DSS.Groups.CLIMATE:return _("Climate");case DSS.Groups.AUDIO:return _("Audio");case DSS.Groups.VIDEO:return _("Video");case DSS.Groups.SECURITY:return _("Security");case DSS.Groups.ACCESS:return _("Access");case DSS.Groups.JOKER:return _("Joker");case DSS.Groups.WHITE:return _("White");case DSS.Groups.DISPLAYS:return _("Displays");default:return _("error");}},toColorString:function(grp){switch(grp){case DSS.Groups.ALL:case DSS.Groups.ANY:return'rainbow';case DSS.Groups.LIGHT:return'yellow';case DSS.Groups.SHADOW:return'grey';case DSS.Groups.CLIMATE:return'blue';case DSS.Groups.AUDIO:return'cyan';case DSS.Groups.VIDEO:return'magenta';case DSS.Groups.SECURITY:return'red';case DSS.Groups.ACCESS:return'green';case DSS.Groups.JOKER:return'black';case DSS.Groups.WHITE:return'white';default:return'black';}},toModel:function(grp,zone){var model;if(zone){model=zone.groups().getById(grp);if(model){return model;}}
return Ext.create('DSS.apartment.GroupModel',{id:grp,text:DSS.Groups.toString(grp)});}}});Ext.define('DSS.types.ActionModel',{extend:'Ext.data.Model',fields:[{name:'id',type:'integer',persist:false},{name:'text',type:'string',persist:false},{name:'icon',type:'string',persist:false},{name:'incomplete',type:'boolean',defaultValue:true},'url','hle',{name:'activity_type',type:'auto'},{name:'output',type:'integer'}],hasMany:[{name:'zone',model:'DSS.apartment.ZoneModel'},{name:'group',model:'DSS.apartment.GroupModel'},{name:'device',model:'DSS.apartment.DeviceModel'},{name:'scene',model:'DSS.apartment.SceneModel'}],statics:{_id:1,genId:function(){return++DSS.types.ActionModel._id;},apartmentStore:null,getApartmentStore:function(){if(!DSS.types.ActionModel.apartmentStore){DSS.types.ActionModel.apartmentStore=Ext.create('DSS.apartment.ApartmentStore');DSS.types.ActionModel.apartmentStore.load();}
return DSS.types.ActionModel.apartmentStore;},reconstructFromIds:function(values){var data=DSS.types.ActionModel.reconstructValues(values);if(data.valid){return new DSS.types.ActionModel(data);}
return new DSS.types.ActionModel();},reconstructValues:function(raw){var values=Ext.apply({},raw),valid=true,zoneStore=DSS.types.ActionModel.getApartmentStore().first().zones(),sceneStore,zone=null,device=null,i=0;if(values.device!==undefined&&values.device.length!==0){values.targetType=DSS.component.TargetType.DEVICE;for(i=0;i<zoneStore.getCount();++i){zone=zoneStore.getAt(i);device=zone.devices().getById(values.device);if(device&&i!==0){break;}}
if(device!==null){values.device=device;values.zone=zone;}else{values.zone=zoneStore.first();}
valid=(!!values.device);}else if(values.zone>=0){values.targetType=DSS.component.TargetType.ZONE;values.zone=zoneStore.getById(values.zone);valid=(!!values.zone);}
if(values.group>=0){if(!!values.zone){values.group=values.zone.groups().getById(values.group);if(!values.group){valid=false;}}}
if(values.blink){values.actionType=DSS.component.ActionType.BLINK;}else if(values.outputValue>=0){values.actionType=DSS.component.ActionType.OUTPUT;values.outputValue=Math.round(values.outputValue/2.55);}else if(values.scene>=0){values.actionType=DSS.component.ActionType.ACTIVITY;sceneStore=DSS.apartment.Helper.getDefaultSceneStore();if(values.zone&&values.group){sceneStore=sceneStore.clone();sceneStore.loadCustomNames(values.zone,values.group);}
values.scene=sceneStore.getById(values.scene);if(!values.scene){valid=false;}}else{valid=false;}
values.valid=valid;return values;}},constructor:function(data,id){if(!id){id=DSS.types.ActionModel.genId();}
this.callParent(arguments);if(data){this.zone().clearFilter();this.group().clearFilter();this.device().clearFilter();this.scene().clearFilter();if(data.zone){delete this.data.zone;this.zone().loadData([data.zone.data]);}
if(data.group){delete this.data.group;this.group().loadData([data.group.data]);}
if(data.device){delete this.data.device;this.device().loadData([data.device.data]);}
if(data.scene){delete this.data.scene;this.scene().loadData([data.scene.data]);}
if(!data.incomplete){this.set('incomplete',false);}}
this.setIcon();this.setText();this.commit();},copy:function(){var data=Ext.clone(this.data);if(this.zone().getCount()>0){data.zone=this.zone().first().copy();}
if(this.group().getCount()>0){data.group=this.group().first().copy();}
if(this.device().getCount()>0){data.device=this.device().first().copy();}
if(this.scene().getCount()>0){data.scene=this.scene().first().copy();}
return new DSS.types.ActionModel(data);},reset:function(){this.zone().clearFilter();this.group().clearFilter();this.device().clearFilter();this.scene().clearFilter();this.zone().removeAll();this.group().removeAll();this.device().removeAll();this.scene().removeAll();this.set('targetType',undefined);this.set('actionType',undefined);this.set('outputValue',undefined);this.set('icon',undefined);this.set('text',undefined);this.set('incomplete',true);this.commit();},setIcon:function(){if(this.data.incomplete){this.set('icon','missing.png');return;}
var icon;var st;if(this.data.actionType===DSS.component.ActionType.ACTIVITY){st=this.scene();if(st.getCount()>0){icon=st.first().get('icon');if(icon&&icon.length>0){this.set('icon',icon);return;}}}
st=this.group().getCount()>0?this.group():this.device();var val=st.first();if(val){icon=val.get('icon');if(icon&&icon.length>0){this.set('icon',icon);return;}}
this.set('icon',null);return;},setText:function(){if(this.data.incomplete){this.set('text',_("Incomplete action..."));return;}
var dev=this.device().first(),zon=this.zone().first(),grp=this.group().first(),scn=this.scene().first();if(this.data.actionType===DSS.component.ActionType.OUTPUT){if(dev){if(zon.get('id')===0){this.set('text',Ext.String.format('{0}: {1}%',dev.get('text'),this.data.outputValue));return;}
this.set('text',Ext.String.format('{0} in {1}: {2}%',dev.get('text'),zon.get('text'),this.data.outputValue));return;}
if(grp){this.set('text',Ext.String.format('{0} in {1}: {2}%',grp.get('text'),zon.get('text'),this.data.outputValue));return;}}
if(this.data.actionType===DSS.component.ActionType.ACTIVITY){if(dev){if(zon.get('id')===0){this.set('text',Ext.String.format(_('{0} for {1}'),scn.get('text'),dev.get('text')));return;}
this.set('text',Ext.String.format(_('{0} for {1} in {2}'),scn.get('text'),dev.get('text'),zon.get('text')));return;}
if(grp){this.set('text',Ext.String.format(_('{0} for {1} in {2}'),scn.get('text'),grp.get('text'),zon.get('text')));return;}}
if(this.data.actionType===DSS.component.ActionType.BLINK){if(dev){if(zon.get('id')===0){this.set('text',Ext.String.format(_('Blink {0}'),dev.get('text')));return;}
this.set('text',Ext.String.format(_('Blink {0} in {1}'),dev.get('text'),zon.get('text')));return;}
if(grp){this.set('text',Ext.String.format(_('Blink {0} in {1}'),grp.get('text'),zon.get('text')));return;}}
this.set('text',_("error"));}});Ext.define('DSS.types.ActionType',{statics:{APT_SCENE:'ACT_APT_SCENE',DEVICE:'ACT_DEVICE',HLE:'ACT_HLE',URL:'ACT_URL',ZONE_ACTIVITY:'ACT_ZONE',toString:function(at){switch(at){case DSS.types.ActionType.APT_SCENE:return _("Call an apartment activity");case DSS.types.ActionType.DEVICE:return _("Set a device");case DSS.types.ActionType.HLE:return _("Use a high level event");case DSS.types.ActionType.URL:return _("Retrieve a URL");case DSS.types.ActionType.ZONE_ACTIVITY:return _("Call activity in a room");default:return _("error");}}}});Ext.define('DSS.types.ActionTypeModel',{extend:'Ext.data.Model',idProperty:'action',fields:['action','icon','text']});Ext.define('DSS.types.TriggerType',{statics:{APT_SCENE:'TRG_APT_SCENE',DEVICE:'TRG_DEVICE',HLE:'TRG_HLE',ZONE_ACTIVITY:'TRG_ZONE',toString:function(tt){switch(tt){case DSS.types.TriggerType.APT_SCENE:return _("Call an apartment activity");case DSS.types.TriggerType.DEVICE:return _("Set a device");case DSS.types.TriggerType.HLE:return _("Use a high level event");case DSS.types.TriggerType.ZONE_ACTIVITY:return _("Call activity in a room");default:return _("error");}}}});Ext.define('DSS.types.ActivityType',{statics:{BLINK:'ATY_BLINK',GROUP_ACTIVITY:'ATY_GRP_ACTIVITY',ZONE_SCENE:'ATY_ZONE_SCENE',toString:function(at){switch(at){case DSS.types.ActivityType.GROUP_ACTIVITY:return _("Call activity in a group");case DSS.types.ActivityType.BLINK:return _("Blink");case DSS.types.ActivityType.ZONE_SCENE:return _("Call a room activity");default:return _("error");}}}});Ext.define('DSS.types.ActionSelectionModel',{extend:'Ext.data.Model',fields:[{name:'id',type:'string',persist:false},{name:'action_type',type:'auto'},{name:'zone_scene',type:'integer',defaultValue:-1},'url','hle',{name:'text',type:'string',persist:false},{name:'icon',type:'string',persist:false}]});Ext.define('DSS.types.ActivitySelectionModel',{extend:'Ext.data.Model',fields:[{name:'id',type:'string',persist:false},{name:'activity_type',type:'auto'},{name:'apt_scene',type:'integer',defaultValue:-1},{name:'group',type:'integer',defaultValue:-1},{name:'text',type:'string',persist:false},{name:'icon',type:'string',persist:false}],constructor:function(data){if(!data.id){data.id=data.activity_type;if(data.group>=0){data.id+='_'+data.group;}
if(data.apt_scene>=0){data.id+='_'+data.apt_scene;}}
this.callParent(arguments);}});